﻿/// <reference path="jquery.js" />
/// <reference path="dq.js" />
/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009-2010 M., Koji
* Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
*
* Date: 2010-04-01 17:34:21 -0900
* Revision: 0003
*/
DQ.Random = {}
DQ.Random.table = [
    7, 182, 240, 31, 85, 91, 55, 227, 174, 79, 178, 94, 153, 246, 119, 203,
    96, 143, 67, 62, 167, 76, 45, 136, 199, 104, 215, 209, 194, 242, 193, 221,
    170, 147, 22, 247, 38, 4, 54, 161, 70, 78, 86, 190, 108, 110, 128, 213,
    181, 142, 164, 158, 231, 202, 206, 33, 255, 15, 212, 140, 230, 211, 152, 71,
    244, 13, 21, 237, 196, 228, 53, 120, 186, 218, 39, 97, 171, 185, 195, 125,
    133, 252, 149, 107, 48, 173, 134, 0, 141, 205, 126, 159, 229, 239, 219, 89,
    235, 5, 20, 201, 36, 44, 160, 60, 68, 105, 64, 113, 100, 58, 116, 124,
    132, 19, 148, 156, 150, 172, 180, 188, 3, 222, 84, 220, 197, 216, 12, 183,
    37, 11, 1, 28, 35, 43, 51, 59, 151, 27, 98, 47, 176, 224, 115, 204,
    2, 74, 254, 155, 163, 109, 25, 56, 117, 189, 102, 135, 63, 175, 243, 251,
    131, 10, 18, 26, 34, 83, 144, 207, 122, 139, 82, 90, 73, 106, 114, 40,
    88, 138, 191, 14, 6, 162, 253, 250, 65, 101, 210, 77, 226, 92, 29, 69,
    30, 9, 17, 179, 95, 41, 121, 57, 46, 42, 81, 217, 93, 166, 234, 49,
    129, 137, 16, 103, 245, 169, 66, 130, 112, 157, 146, 87, 225, 61, 241, 249,
    238, 8, 145, 24, 32, 177, 165, 187, 198, 72, 80, 154, 214, 127, 123, 233,
    118, 223, 50, 111, 52, 168, 208, 184, 99, 200, 192, 236, 75, 232, 23, 248
];

//初期位置を決定
DQ.Random.pos = Math.floor(Math.random() * 255) % 256;

DQ.Random.getValue = function (range) {
    ///<summary>
    /// 乱数の値を取得します。レンジ配列が指定されていればどの要素にマッチしたかを返します。
    ///</summary>
    ///<param name="range" type="Array({l,g})">
    /// 値の範囲を指定
    ///</param>

    var v = DQ.Random.table[DQ.Random.pos];
    DQ.Random.pos = Math.floor(DQ.Random.pos + Math.random() * 255) % 256;
    if (range == null) {
        //範囲指定がなければ、そのままかえす（256等分)
        return v;
    }
    for (var i = 0; i < range.length; i++) {
        if (range[i].l <= v && v < range[i].g) {
            return i;
        }
    }

    //マッチしない
    return i - 1;
}

DQ.Random.mod = function (resolution) {
    var v = DQ.Random.table[DQ.Random.pos] % resolution;
    DQ.Random.pos = Math.floor(DQ.Random.pos + Math.random() * 255) % 256;
    return v;
}

DQ.Random.judge = function (range) {
    ///<summary>
    /// 指定のレンジに現在の乱数値が収まるかを判定する
    ///</summar>
    ///<param name="range" type="{l,g}">
    /// 値の範囲を指定
    ///</param>

    var v = DQ.Random.table[DQ.Random.pos];
    DQ.Random.pos = Math.floor(DQ.Random.pos + Math.random() * 255) % 256;
    return range.l <= v && v < range.g;
}

//等分
DQ.Random.DivideTwo = [{ l: 0, g: 128 }, { l: 128, g: 256}];
DQ.Random.DivideThree = [{ l: 0, g: 86 }, { l: 86, g: 172 }, { l: 172, g: 256}];
DQ.Random.DivideFour = [{ l: 0, g: 64 }, { l: 64, g: 128 }, { l: 128, g: 192 }, { l: 192, g: 256}];
DQ.Random.DivideEight = [
    { l: 0, g: 32 }, { l: 32, g: 64 }, { l: 64, g: 96 }, { l: 96, g: 128 },
    { l: 128, g: 160 }, { l: 160, g: 192 }, { l: 192, g: 224 }, { l: 224, g: 256}];

//ここから拡張

//だれ
DQ.Random.Range = {}
DQ.Random.Range.MonsterGroup8 = [
    { l: 0, g: 43 },
    { l: 43, g: 86 },
    { l: 86, g: 129 },
    { l: 129, g: 172 },
    { l: 172, g: 204 },
    { l: 204, g: 236 },
    { l: 236, g: 252 },
    { l: 252, g: 256 }
];
DQ.Random.Range.MonsterGroup4 = [
    { l: 0, g: 90 },
    { l: 90, g: 180 },
    { l: 180, g: 240 },
    { l: 240, g: 256 }
];
DQ.Random.Range.MonsterGroup5 = [
    { l: 0, g: 90 },
    { l: 90, g: 180 },
    { l: 180, g: 235 },
    { l: 235, g: 250 },
    { l: 250, g: 256 }
];
//どれ
DQ.Random.Range.DropItemGroup = [
    { l: 0, g: 128 },
    { l: 128, g: 208 },
    { l: 208, g: 252 },
    { l: 252, g: 256 }
]
//落とした?
DQ.Random.Range.DropItem = [
    { l: 0, g: 256 },
    { l: 0, g: 128 },
    { l: 0, g: 32 },
    { l: 0, g: 16 },
    { l: 0, g: 8 },
    { l: 0, g: 2 },
    { l: 0, g: 1 },
    { l: 0, g: 0 }
]

DQ.Random.Range.Rule = [
[    { l: 0, g: 32 },
    { l: 32, g: 64 },
    { l: 64, g: 96 },
    { l: 96, g: 128 },
    { l: 128, g: 160 },
    { l: 160, g: 192 },
    { l: 192, g: 224 },
    { l: 224, g: 256 }
],
[    { l: 0, g: 38 },
    { l: 38, g: 77 },
    { l: 77, g: 110 },
    { l: 110, g: 144 },
    { l: 144, g: 174 },
    { l: 174, g: 204 },
    { l: 204, g: 230 },
    { l: 230, g: 256 }
],
[    { l: 0, g: 46 },
    { l: 38, g: 91 },
    { l: 77, g: 129 },
    { l: 110, g: 163 },
    { l: 144, g: 193 },
    { l: 174, g: 219 },
    { l: 204, g: 241 },
    { l: 230, g: 256 }
],
[    { l: 0, g: 100 },
    { l: 38, g: 150 },
    { l: 77, g: 178 },
    { l: 110, g: 202 },
    { l: 144, g: 221 },
    { l: 174, g: 236 },
    { l: 204, g: 248 },
    { l: 230, g: 256 }
]]


DQ.Random.EncountSeed = [0, 0, 12, 5, 10, 10, 14, 10, 0, 6, 10, 0];
DQ.Random.EncountThreshold = [0, 255, 128, 85, 64, 51, 42, 36, 32, 28, 25, 23, 21, 19, 18, 17, 16];
