﻿/// <reference path="jquery.js" />
/// <reference path="dq.js" />
/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009 M., Koji
* Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
*
* Date: 2009-11-01 17:34:21 -0900
* Revision: 0002
*/

DQ = DQ || {};
DQ._ctrl_ = DQ._ctrl_ || [];

DQ.lazyLoad(DQ.subdir + "dq-core.js", "DQ.Window", function () {
    DQ.JsonSerializer = function (type) {
        /// <summary>
        /// オブジェクトをJSON形式へシリアル化します。
        /// アンダースコア(_)で始まる属性はprivate属性と見なし、_を省略したgetter関数がなければ無視します。
        /// </summary>
        /// <param name="type" type="object">
        /// deserializeする際に型を特定するためのオブジェクトを指定。
        /// typeの指定が無ければ単にeval()した値を返します。
        /// </param>
        this.type = type;
    }
    DQ.JsonSerializer.prototype = {
        deli: "\n",
        serialize: function (object) {
            ///<summary>
            /// 渡されたオブジェクトをシリアル化します。
            ///</summary>

            var bo = new Array(),
            to = new Array(),
            isArray = object instanceof Array,
            extend = false;
            bo.push(isArray ? "[" + this.deli : "{" + this.deli);
            for (var nm in object) {
                var elem = object[nm],
                value = elem;
                //関数は無視
                if (typeof elem == "function") {
                    continue;
                }
                //private 属性
                if (nm.charAt(0) == '_') {
                    nm = nm.substring(1);
                    if (object[nm] && typeof object[nm] == "function") {
                        value = object[nm].apply(object);
                    } else {
                        //getterがなければ無視
                        continue;
                    }
                }
                if (isArray) {
                    if (isNaN(nm) && extend == false) {
                        bo.unshift("{ 'this' :");
                        isArray = false;
                        if (to.length) {
                            var last = to[to.length - 1] + "]";
                            to.splice(to.length - 1, 1, last);
                        } else {
                            to.push("]");
                        }
                    }
                }
                var _nm = (isArray) ? "" : "'" + nm + "' : ";
                switch (typeof value) {
                    case "string":
                        to.push(_nm + '"' + value + '"');
                        break;
                    case "number":
                    case "boolean":
                        to.push(_nm + value);
                        break;
                    case "object":
                        if (nm == "owner") {
                            var __x__ = 0;
                        }
                        if (value != this && nm != "owner") {
                            //循環を回避だけど・・・
                            to.push(_nm + this.serialize(value));
                        }

                        break;
                }
            }
            bo.push(to.join(',' + this.deli));
            bo.push(this.deli + (isArray ? "]" : "}"));

            return bo.join('');
        },
        deserialize: function (json) {
            if (typeof json == "string") {
                eval("var r =" + json);
            } else {
                var r = json;
            }
            if (!this.type) {
                return r;
            }
            var to = new this.type(),
            _deserialize = function (r, to) {
                for (var nm in to) {
                    if (typeof to[nm] == "function") {
                        continue;
                    }
                    //private 属性
                    if (nm.charAt(0) == '_') {
                        nm = nm.substring(1);
                        if (typeof r[nm] == "undefined") {
                            continue;
                        }
                        if (to[nm] && typeof to[nm] == "function") {
                            value = to[nm].apply(to, [r[nm]]);
                        } else {
                            //getterがなければ無視
                            continue;
                        }
                    } else {
                        if (nm == "temporary") {
                            continue;
                        }

                        if (typeof r[nm] == "undefined") {
                            continue;
                        }
                        if (typeof to[nm] == "object" && !(to[nm] instanceof Array) && to[nm] != null) {
                            _deserialize(r[nm], to[nm]);
                        } else if (typeof to[nm] == "object" && to[nm] instanceof Array && r[nm]["this"] != null) {
                            for (var i = 0; i < r[nm]["this"].length; i++) {
                                to[nm].push(r[nm]["this"][i]);
                                _deserialize(r[nm]["this"][i], to[nm][i]);
                            }
                            _deserialize(r[nm], to[nm]);
                        } else if (to[nm] instanceof Array) {
                            for (var i = 0; i < r[nm].length; i++) {
                                to[nm].push(r[nm][i]);
                                _deserialize(r[nm][i], to[nm][i]);
                            }
                        } else {
                            if (typeof to[nm] == "boolean" || r[nm] == "true" || r[nm] == "false") {
                                to[nm] = r[nm] == "true";
                            } else {
                                to[nm] = r[nm];
                            }
                        }
                    }
                }
            }

            _deserialize(r, to);
            return to;
        }
    }

    if (typeof DOMParser == 'undefined') {
        DOMParser = function () { }
        DOMParser.prototype.parseFromString = function (str, contentType) {
            if (typeof (ActiveXObject) != 'undefined') {
                var xmldata = new ActiveXObject('MSXML.DomDocument');
                xmldata.async = false;
                xmldata.loadXML(str);
                return xmldata;
            } else if (typeof (XMLHttpRequest) != 'undefined') {
                var xmldata = new XMLHttpRequest;
                if (!contentType) {
                    contentType = 'application/xml';
                }
                xmldata.open('GET', 'data:' + contentType + ';charset=utf-8,' + encodeURIComponent(str), false);
                if (xmldata.overrideMimeType) {
                    xmldata.overrideMimeType(contentType);
                }
                xmldata.send(null);
                return xmldata.responseXML;
            }
        }
    }

    DQ.XmlSerializer = function (type) {
        /// <summary>
        /// オブジェクトをXML形式へシリアル化します。
        /// アンダースコア(_)で始まる属性はprivate属性と見なし、_を省略したgetter関数がなければ無視します。
        /// </summary>
        /// <param name="type" type="object">
        /// deserializeする際に型を特定するためのオブジェクトを指定。
        /// typeの指定が無ければ単にeval()した値を返します。
        /// </param>
        this.type = type;
    }
    DQ.XmlSerializer.prototype = {
        deli: "\n",
        serialize: function (object, root) {
            ///<summary>
            /// 渡されたオブジェクトをシリアル化します。
            ///</summary>
            var me = this;
            function _serialize(object) {
                var bo = new Array(),
                to = new Array(),
                isArray = object instanceof Array;
                //bo.push(isArray ? "[" + this.deli : "{" + this.deli);
                for (var nm in object) {
                    var elem = object[nm],
                    value = elem;
                    //関数は無視
                    if (typeof elem == "function") {
                        continue;
                    }
                    //private 属性
                    if (nm.charAt(0) == '_') {
                        nm = nm.substring(1);
                        if (object[nm] && typeof object[nm] == "function") {
                            value = object[nm].apply(object);
                        } else {
                            //getterがなければ無視
                            continue;
                        }
                    }
                    var lb = (isArray) ? "<string>" : "<" + nm + ">";
                    var rb = (isArray) ? "</string>" : "</" + nm + ">";
                    switch (typeof value) {
                        case "string":
                            to.push(lb + value + rb);
                            break;
                        case "number":
                            to.push(lb + value + rb);
                            break;
                        case "object":
                            to.push(lb + _serialize(value) + rb);
                            break;
                    }
                }
                bo.push(to.join(me.deli));
                //bo.push(this.deli + (isArray ? "]" : "}"));

                return bo.join('');
            }

            return '<?xml version="1.0" encoding="UTF-8" ?><root>' + this.deli + _serialize(object) + '</root>';
        },
        deserialize: function (xml) {
            /// <summary>
            /// XML(DOMまたは文字列)をオブジェクトへ変換します。
            /// </summary>
            /// <param name="xml" type="DOM or string">
            /// 変換対象のXMLを指定
            /// </param>

            var to = {},
            object = {},
        _deserialize = function (r, to) {
            for (var nm in to) {
                if (typeof to[nm] == "function") {
                    continue;
                }
                //private 属性
                if (nm.charAt(0) == '_') {
                    nm = nm.substring(1);
                    if (typeof r[nm] == "undefined") {
                        continue;
                    }
                    if (to[nm] && typeof to[nm] == "function") {
                        value = to[nm].apply(to, [r[nm]]);
                    } else {
                        //getterがなければ無視
                        continue;
                    }
                } else {
                    if (typeof r[nm] == "undefined") {
                        continue;
                    }
                    if (typeof to[nm] == "object" && !(to[nm] instanceof Array) && to[nm] != null) {
                        _deserialize(r[nm], to[nm]);
                    } else {
                        to[nm] = r[nm];
                    }
                }
            }
        },
            _preprocess = function (xml, to) {
                if (xml.attributes == null) {
                    return to;
                }
                for (var i = 0; i < xml.attributes.length; i++) {
                    var c = xml.attributes[i];
                    to[c.nodeName] = $(c).text();
                }
                for (var i = 0; i < xml.childNodes.length; i++) {
                    var c = xml.childNodes[i];
                    if (c.nodeName == "#text") {
                        continue;
                    } else if (c.nodeName == "string") {
                        if (!(to instanceof Array)) {
                            to = [];
                        }
                        to.push($(c).text());
                    } else if (c.childNodes.length == 1 && c.childNodes[0].nodeType != 1) {
                        if (to[c.nodeName]) {
                            if (!(to[c.nodeName] instanceof Array)) {
                                var tmp = to[c.nodeName];
                                to = [];
                                to.push(tmp);
                            }
                            to.push($(c).text());
                        } else {
                            if (to instanceof Array) {
                                to.push($(c).text());
                            } else {
                                to[c.nodeName] = $(c).text();
                            }
                        }
                    } else {
                        if (to[c.nodeName]) {
                            if (!(to[c.nodeName] instanceof Array)) {
                                var tmp = to[c.nodeName];
                                to[c.nodeName] = [];
                                to[c.nodeName].push(tmp);
                            }
                            var value = {};
                            value = _preprocess(c, value);
                            to[c.nodeName].push(value);
                        } else {
                            to[c.nodeName] = {};
                            to[c.nodeName] = _preprocess(c, to[c.nodeName]);
                        }
                    }
                }
                return to;
            }

            var object = {};
            try {
                if (typeof xml == "string") {
                    var parser = new DOMParser();
                    xml = parser.parseFromString(xml, "text/xml");
                }
                if (!xml.lastChild) {
                    return {};
                }
                object = _preprocess(xml.lastChild, object);
                if (!this.type) {
                    return object;
                }
                var to = new this.type;
                _deserialize(object, to);
            } catch (e) {
                alert(e.message);
            }
            return to;
        }
    }

    DQ.Catalog.prototype.json = function () {
        var json = new DQ.JsonSerializer();
        return json.serialize(this.catalog);
    }
});
