﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="../dq-core.js" />
/// <reference path="dq-rpg.js" />
/// <reference path="dq-rpg-attack.js" />

DQ.lazyLoad(DQ.subdir + "rpg/dq-rpg.js", "DQ.RPG.InputBox", function () {

    DQ.RPG.Command = function () { }
    DQ.RPG.Command.prototype = { from: null, to: null, by: null, command: "", trigger: null, enter: null }

    //コマンドごとのストラテジーを作成
    DQ.RPG.Command.Nothing = dqextend(DQ.RPG.Command, function () {
        this.command = "nothing";
    });
    DQ.RPG.Command.Nothing.prototype = {
        enter: function (engnine, text) {
            return true;
        },
        trigger: function (engine, text) {
            for (var i = 0; i < this.from.temporary.length; i++) {
                this.from.temporary[i].text && text.push(DQ.format(this.from.temporary[i].text, this.from.name));
            }
            return false;
        }
    }
    DQ.RPG.Command.Attack = dqextend(DQ.RPG.Command, function () {
        this.command = "attack";
    });
    DQ.RPG.Command.Attack.prototype = {
        enter: function (engnine, text) {
            return true;
        },
        trigger: function (engine, text) {
            return this.by.attack(this.from, this.to, text);
        }
    }

    DQ.RPG.Command.Defence = dqextend(DQ.RPG.Command, function () {
        this.command = "defence";
    });
    DQ.RPG.Command.Defence.prototype = {
        enter: function (engnine, text) {

            //身を守る
            this.from.defence();
            return true;
        },
        trigger: function (engine, text) {
            text.push(this.from.name + "は身を守っている。");
            return true;
        }
    }
    DQ.RPG.Command.Magic = dqextend(DQ.RPG.Command, function () {
        this.command = "magic";
    });
    DQ.RPG.Command.Magic.prototype = {
        enter: function (engnine, text) {
            return true;
        },
        trigger: function (engine, text) {
            return this.by.chant(this.from, this.to, text);
        }
    }
    DQ.RPG.Command.Tool = dqextend(DQ.RPG.Command, function () {
        this.command = "useItem";
    });
    DQ.RPG.Command.Tool.prototype = {
        enter: function (engnine, text) {
            return true;
        },
        trigger: function (engine, text) {
            return this.by.use(this.from, this.to, text);
        }
    }
    DQ.RPG.Command.Escape = dqextend(DQ.RPG.Command, function () {
        this.command = "escape";
    });
    DQ.RPG.Command.Escape.prototype = {
        enter: function (engnine, text) {
            return true;
        },
        trigger: function (engine, text) {
            var _remove = function (party, from) {
                for (var i = 0; i < party.length; i++) {
                    if (party[i]._origin == from) {
                        party[i].escaped = true;
                        from.escaped = true;
                        from.ePos.escaped = true;
                        return true;
                    }
                }

                return false;
            }
            var party = this.from.friend ? engine.enemy : engine.party;
            var fromParty = this.from.friend ? engine.cast_party : engine.cast_enemy;

            text.push(DQ.format("{0} は、その場から逃げ出した。", this.from.name));
            //先制攻撃、敵、後は確率
            if (engine.preemptive ||
                !this.from.friend || 
                party.eachFrom('escape', this.from, true)) {
                if (!this.from.friend) {
                    _remove(fromParty, this.from);
                }
                return true;
            } else {
                text.push(DQ.format("{0} は、回り込まれた。", this.from.name));
                return false;
            }
        }
    }
});