﻿/// <reference path="../dq.js" />
/// <reference path="dq-rpg.js" />
/// <reference path="dq-rpg-attack.js" />

/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009-2010 M., Koji
* Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
*
* Date: 2010-04-01 17:34:21 -0900
* Revision: 0007
*/
DQ.lazyLoad(DQ.subdir + "rpg/dq-rpg.js", "DQ.RPG.InputBox", function () {

    DQ.RPG.Item = function (options) {
        /// <summary>
        ///     アイテムの構造を保持します。
        /// </summary>

        options = options || {};
        var c = DQ.RPG.Item.Category;
        switch (options.category) {
            case c.Item:
            case c.Event:
                options = DQ.options(options, {
                    uid: 0,
                    name: "unk",
                    text: "不明",
                    type: "",
                    description: "不明",
                    category: "",
                    STR: 0,
                    VIT: 0,
                    AGI: 0,
                    ATK: 0,
                    DEF: 0,
                    HP: 0,
                    MP: 0,
                    count: 1,
                    Buy: 0,
                    Sell: 0,
                    img: "data/item_default.png"
                });
                break;
            case c.Weapon:
                options = DQ.options(options, {
                    uid: 0,
                    name: "unk",
                    text: "不明",
                    description: "不明",
                    category: "",
                    type: "weapon",
                    STR: 0,
                    VIT: 0,
                    AGI: 0,
                    ATK: 0,
                    DEF: 0,
                    HP: 0,
                    MP: 0,
                    count: 1,
                    Buy: 0,
                    Sell: 0,
                    img: "data/item_default.png"
                });
                break;
            case c.Armor:
                options = DQ.options(options, {
                    uid: 0,
                    name: "unk",
                    text: "不明",
                    description: "不明",
                    category: "",
                    type: "armor",
                    STR: 0,
                    VIT: 0,
                    AGI: 0,
                    ATK: 0,
                    DEF: 0,
                    HP: 0,
                    MP: 0,
                    count: 1,
                    Buy: 0,
                    Sell: 0,
                    img: "data/item_default.png"
                });
                break;
            case c.Shield:
                options = DQ.options(options, {
                    uid: 0,
                    name: "unk",
                    text: "不明",
                    description: "不明",
                    category: "",
                    type: "shield",
                    STR: 0,
                    VIT: 0,
                    AGI: 0,
                    ATK: 0,
                    DEF: 0,
                    HP: 0,
                    MP: 0,
                    count: 1,
                    Buy: 0,
                    Sell: 0,
                    img: "data/item_default.png"
                });
                break;
            case c.Accesary:
                options = DQ.options(options, {
                    uid: 0,
                    name: "unk",
                    text: "不明",
                    description: "不明",
                    category: "",
                    type: "accesary",
                    STR: 0,
                    VIT: 0,
                    AGI: 0,
                    ATK: 0,
                    DEF: 0,
                    HP: 0,
                    MP: 0,
                    count: 1,
                    Buy: 0,
                    Sell: 0,
                    img: "data/item_default.png"
                });
                break;
            default:
                options = DQ.options(options, {
                    uid: 0,
                    name: "unk",
                    text: "不明",
                    description: "不明",
                    category: "",
                    type: "",
                    STR: 0,
                    VIT: 0,
                    AGI: 0,
                    ATK: 0,
                    DEF: 0,
                    HP: 0,
                    MP: 0,
                    count: 1,
                    Buy: 0,
                    Sell: 0,
                    img: "data/item_default.png"
                });
        }

        this._create(options);
        this._strategy = this._buildStrategy(options);
    }
    var tmp = DQ.RPG.Item.Category = { Item: "つかうもの", Event: "だいじなもの", Weapon: "武器", Armor: "防具", Shield: "盾", Accesary: "装飾品" };
    DQ.RPG.Item.CategoryMaster = [
    { name: tmp.Item, start: 10000 },
    { name: tmp.Weapon, start: 20000 },
    { name: tmp.Armor, start: 30000 },
    { name: tmp.Shield, start: 40000 },
    { name: tmp.Accesary, start: 50000 },
    { name: tmp.Event, start: 60000}];
    delete tmp;

    DQ.RPG.Item.Category = { Item: "つかうもの", Event: "だいじなもの", Weapon: "武器", Armor: "防具", Shield: "盾", Accesary: "装飾品" };
    DQ.RPG.Item.table = [];
    DQ.RPG.ItemStg = function (options) {
        this.owner = options;
    }
    DQ.RPG.ItemStg.prototype = {
        owner: null,
        equip: function () {
        },
        remove: function () {
        },
        canUse: function () {
            return this.owner.uid < 20000 || this.owner.uid >= 50000;
        },
        use: function (from, to, text) {
            text.push("何もおこらなかった。");

            return false;
        }
    }
    DQ.RPG.Item.prototype = {
        clone: function () {
            var guid = new DQ.Guid();
            var c = new DQ.RPG.Item();
            for (var nm in this) {
                if (this.hasOwnProperty(nm)) {
                    c[nm] = this[nm];
                }
            }
            c.serial = guid.generate();

            return c;
        },
        _strategy: new DQ.RPG.ItemStg(),
        _buildStrategy: function (options) {
            for (var i = 0; i < DQ.RPG.Item.table.length; i++) {
                if (DQ.RPG.Item.table[i].type == options.type || DQ.RPG.Item.table[i].uid == options.uid) {
                    return new DQ.RPG.Item.table[i].strategy(this);
                }
            }
            return new DQ.RPG.ItemStg(this);
        },
        _create: function (options) {
            var c = DQ.RPG.ItemCatalog;
            for (var nm in options) {
                if (!isNaN(parseInt(options[nm]))) {
                    this[nm] = parseInt(options[nm]);
                } else {
                    this[nm] = options[nm];
                }
            }
            this._countMax = this.count;
        },
        importFrom: function (src) {
            for (var nm in this) {
                if (!this.hasOwnProperty(nm)) {
                    continue;
                }
                if (!isNaN(parseInt(src[nm]))) {
                    this[nm] = parseInt(src[nm]);
                } else {
                    this[nm] = src[nm];
                }
            }
        },
        count: 1,
        canUse: function () {
            return this._strategy.canUse();
        },
        equip: function (to) {
            this._strategy.equip(to);
        },
        remove: function (from) {
            this._strategy.remove(from);
        },
        use: function (from, to, text) {
            text.push(DQ.format("{0} は、 {1} を使った。", from.name, this.text));
            var res = this._strategy.use(from, to, text);
            if (res && this.count > 0) {
                //使用回数を減算
                this.count--;
                if (this.count == 0) {
                    from.decrementItem(this.uid, 1);

                    //同一のアイテムを複数個持っている（かつ個別には管理していない）ので、
                    //使用回数を元に戻しておく。
                    this.count = this._countMax;
                }
            }

            return res;
        },
        drop: function (owner) {
            owner.decrementItem(this.uid, 1);
        }
    }

    DQ.RPG.Item.Herb = dqextend(DQ.RPG.ItemStg, function (owner) {
        this.base(owner);
    }, {
        use: function (from, to, text) {
            var st = to.parmanent,
                hp = world.getPower(this.owner.HP);
            delta = (to.hp() + hp >= to.maxHP()) ?
                        to.maxHP() - to.hp() : to.hp() + hp;

            if (delta == 0) {
                text.push("HPは回復しませんでした。");
            } else {
                text.push(to.name + "は " + delta + "ポイントのHPを回復した。");
            }
            to.hp(to.hp() + delta);

            //from.decrementItem(this.owner.id, 1);

            return true;
        }
    });

    DQ.RPG.Item.Seed = dqextend(DQ.RPG.ItemStg, function (owner) {
        this.base(owner);
    }, {
        equip: function (to) {
        },
        remove: function (from) {
        },
        use: function (from, to, text) {
            var me = this;
            var _check = function (name) {
                var v = me.owner[name];
                if (v) {
                    if (name == "HP" || name == "HP") {
                        name = 'max' + name;
                    }
                    to.status(name, to.status(name) + v);
                    text.push(DQ.format(
                        "{0} の {1} が {2} ポイント上昇した。", to.name, name, v));
                }
            }
            _check('HP');
            _check('MP');
            _check('STR');
            _check('VIT');
            _check('AGI');

            return true;
        }
    });

    DQ.RPG.Item.Party = dqextend(DQ.RPG.ItemStg, function (owner) {
        this.base(owner);
    }, {
        use: function (party, to, text) {
            return world.useItemForParty(this.owner, party, to, text);
        }
    });

    DQ.RPG.Item.Jump = dqextend(DQ.RPG.ItemStg, function (owner) {
        this.base(owner);
    }, {
        use: function (party, to, text) {
            world.jump('map', to.position[0], to.position[1] + 2);
            return true;
        }
    });

    DQ.RPG.Item.table.push({ type: "herb", strategy: DQ.RPG.Item.Herb });
    DQ.RPG.Item.table.push({ type: "seed", strategy: DQ.RPG.Item.Seed });
    DQ.RPG.Item.table.push({ type: "party", strategy: DQ.RPG.Item.Party });
    DQ.RPG.Item.table.push({ type: "jump", strategy: DQ.RPG.Item.Jump });

    DQ.RPG.ItemCatalog = function (options) {
        /// <summary>
        /// </summary>

        options = DQ.options(options, {
            url: "data/item.txt",
            callback: null
        });

        this.onLoaded = options.callback;
        this.url = options.url;
        this._max = [];
        var start = 9999;
        for (var i = 0; i < DQ.RPG.Item.CategoryMaster.length; i++) {
            var ms = DQ.RPG.Item.CategoryMaster[i];
            this._max[ms.name] = ms.start;
        }
        this.url && this.load(this.url);
    }

    DQ.RPG.ItemCatalog.prototype = {
        catalog: [],
        onLoaded: function () { },
        createItem: function (category) {
            if (this._max[category] == undefined) {
                throw "不明なカテゴリーです。新しいカテゴリーは事前に登録しておく必要があります。";
            }
            for (var pos = 0; pos < DQ.RPG.Item.CategoryMaster.length; pos++) {
                if (DQ.RPG.Item.CategoryMaster[pos].name == category) {
                    break;
                }
            }
            var uid = -1;
            for (var i = DQ.RPG.Item.CategoryMaster[pos].start + 1; i < this._max[category]; i++) {
                if (!this.catalog[i]) {
                    uid = i;
                    break;
                }
            }
            if (uid == -1) {
                this._max[category]++;
                uid = this._max[category];
            }
            return new DQ.RPG.Item({ uid: uid, category: category });
        },
        load: function (url, callback) {
            var me = this;
            DQ.loadCatalog(url, function (data) {
                try {
                    eval('var s=' + data);
                } catch (ex) {
                    alert(DQ.format("DQ.RPG.ItemCatalog.load::カタログに文法エラー発生:{0}", ex.Message));
                    me.onLoaded && me.onLoaded(me, false);
                }
                me._data = s.data || s.catalog;
                me.version = s.version;
                me.catalog.length = 0;
                me.catalog = [];
                for (var i = 0; i < me._data.length; i++) {
                    var item;
                    if (me._data[i].type == "weapon") {
                        item = new DQ.RPG.Weapon(me._data[i]);
                    } else {
                        item = new DQ.RPG.Item(me._data[i]);
                    }
                    me.catalog[item.uid] = item;
                    if (me._max[item.category] < parseInt(item.uid)) {
                        me._max[item.category] = parseInt(item.uid);
                    }
                    callback && callback(item);
                }
                me.onLoaded && me.onLoaded.apply(me);
            });
        },
        choose: function (player, type) {
            var items = player.items,
                    result = [],
                    cur = [];

            for (var i = 0; i < items.length; i++) {
                if (items[i].uid == undefined) {
                    continue;
                }
                if (this.catalog[items[i].uid].type == type) {
                    if (items[i].equip) {
                        cur.push(items[i]);
                    } else {
                        result.push(items[i]);
                    }
                }
            }
            return cur.concat(result);
        },
        find: function (title) {
            var res = null;
            $.each(this.catalog, function () {
                if (this.title == title) {
                    res = this;
                }
            });

            return res;
        }
    }
});