﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="dq-ui.js" />
/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009 M., Koji
* Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
*
* Date: 2009-11-01 17:34:21 -0900
* Revision: 0007
*/

DQ.lazyLoad(DQ.subdir + "ui/dq-ui.js", "DQ.UI", function () {
    DQ.Data = {};
    DQ.Data.BindSource = dqextend(Array, function (src) {
        ///<summary>
        /// DataGridコントロールに引き渡すデータソースを定義します。
        ///</summary>
        var i = 0,
            _key = [];
        for (var nm in src) {
            if (src.hasOwnProperty(nm)) {
                this[i] = src[nm];
                _key[i] = nm;
                i++;
            }
        }
        this._src = src;
        this.bind = function (o, nm) {
            var l = 0;
            for (var nm in src) {
                if (src.hasOwnProperty(nm)) {
                    this[l] = src[nm];
                    _key[l] = nm;
                    l++;
                }
            }
        }
        var _filter = null,
            _sortOrder = DQ.UI.SortOrder.None,
            _list = src || [],
            _sort_key = "";

        this.list = function (value) {
            if (!arguments.length) {
                return _list;
            }
            _list = value;
            this.filter(_filter, _list);
        }
        this.sort = function (sortKey, order) {
            _sort_key = sortKey;
            _sortOrder = order;
            var tmp = [];
            for (var nm in _list) {
                if (!_list.hasOwnProperty(nm)) {
                    continue;
                }
                tmp.push({ name: nm, value: _list[nm] });
            }
            tmp.sort(function (a, b) {
                if (order == DQ.UI.SortOrder.Ascending) {
                    return (a.value[sortKey] < b.value[sortKey]) ? -1 : 1;
                } else {
                    return (a.value[sortKey] < b.value[sortKey]) ? 1 : -1;
                }
            });
            this.filterEx(_filter, tmp);
        }
        this.sortOrder = function () {
            return _sortOrder;
        }
        this.remove = function (nm) {
            delete _list[nm];
            for (var i = 0; i < _key.length; i++) {
                if (_key[i] == nm) {
                    delete this[i];
                    break;
                }
            }
            if (_sort_key != "") {
                this.sort(_sort_key, _sortOrder);
            } else {
                this.filter(_filter, _list);
            }
        }
        this.filter = function (value, list) {
            if (!arguments.length) {
                return _filter;
            }
            if (!list) {
                list = _list;
            }
            _filter = value;
            _key = [];
            var i = 0;
            for (var nm in this) {
                if (!this.hasOwnProperty(nm) || typeof this[nm] == "function") {
                    continue;
                }
                delete this[nm];
            }
            if (value == null) {
                for (var nm in list) {
                    if (_list.hasOwnProperty(nm)) {
                        this[i] = list[nm];
                        _key[i] = nm;
                        i++;
                    }
                }
                return;
            }
            var s = value.split('=');
            var left = s[0].replace(/^\s+|\s+$/g, "");
            s.splice(0, 1);
            var right = eval(s.join('=').replace(/^\s+|\s+$/g, ""));
            for (var nm in list) {
                var val = list[nm];
                if (val[left] && val[left].toString().match(right)) {
                    this[i] = list[nm];
                    _key[i] = nm;
                    i++;
                }
            }
        }
        this.filterEx = function (value, list) {
            _filter = value;
            _key = [];
            var i = 0;
            for (var nm in this) {
                if (!this.hasOwnProperty(nm) || typeof this[nm] == "function") {
                    continue;
                }
                delete this[nm];
            }
            if (value == null) {
                for (var i = 0; i < list.length; i++) {
                    this[i] = list[i].value;
                    _key[i] = list[i].name;
                }
                return;
            }
            var s = value.split('=');
            var left = s[0].replace(/^\s+|\s+$/g, "");
            s.splice(0, 1);
            var right = eval(s.join('=').replace(/^\s+|\s+$/g, ""));
            var j = 0;
            for (var i = 0; i < list.length; i++) {
                var val = list[i].value;
                if (val[left] && val[left].toString().match(right)) {
                    this[j] = list[i].value;
                    _key[j] = list[i].name;
                    j++;
                }
            }
        }
    },
    {
    });

    DQ.UI.DataColumn = function (options) {
        for (var nm in options) {
            this[nm] = options[nm];
        }
        caption = this.caption == "" ? this.columnName : this.caption;
    }
    DQ.UI.DataColumn.property = {
        caption: "",
        columnName: "",
        dataType: null, //予約
        defaultValue: null,
        image: null, //拡張
        maxLength: 0,   //予約
        readOnly: false,
        width: 0
    }

    DQ.UI.DataGrid = dqextend(DQ.Control, function (parent, options, object) {
        /// <summary>
        /// DataGridコントロールを作成します。
        /// </summary>
        ///<param name="options" type="object">
        /// オプションを指定
        ///</param>
        /// <param name="object" type="string/jQuery">
        /// DataGridコントロールの外殻を指すオブジェクトを指定
        /// </param>

        //options 省略判定
        object = !object && options && (typeof options == "string" || options.jquery) && options || object;
        object = object || $('<div>').addClass('dq-datagrid');
        options = DQ.options(options, {
            text: "",
            columns: null,
            command: null,
            click: null
        });

        var me = this,
            text = options.text;
        this.base(parent, object);
        this.name = options.name || (typeof object == "string") ? object : object.attr('id');
        text && (this._text = text);
        __create(options);

        function __create(options) {
            /// <summary>
            /// DataGridコントロールを作成します。
            /// </summary>
            me.client = $('<div>').addClass("dq-inner").appendTo(me.obj);

            var t_tbl = $('<table>').addClass("dq-header").attr('border', "0").appendTo(me.client).width('100%'),
            t_body = me.t_body = $('<tbody>').appendTo(t_tbl),
            h_div = me.hContainer = $('<div>').addClass("dq-header").appendTo(me.client),
            h_tbl = $('<table>').attr('border', "0").appendTo(h_div),
            h_body = me.h_body = $('<tbody>').appendTo(h_tbl),
            b_div = me.bContainer = $('<div>').addClass("dq-body").appendTo(me.client),
            b_tbl = $('<table>').attr('border', "0").appendTo(b_div),
            b_body = me.b_body = $('<tbody>').appendTo(b_tbl),
            f_tbl = $('<table>').addClass("footer").attr('border', "0").appendTo(me.client),
            f_body = me.f_body = $('<tbody>').appendTo(f_tbl);
            me.columns = options.columns;
            me.command = options.command;
            me.onClick = options.click;
            me.onCommand = options.onCommand;
            me._grip = null;
            me._thW = [];
            me.bind();
        }
    }, {
        buttons: null,
        command: null,
        sortOrder: DQ.UI.SortOrder.None,
        columns: {},
        onClick: null,
        onSelectedIndexChanged: null,
        bind: function (t_body, h_body, b_body, f_body, grip, thW) {
            var me = this,
                scrollTop = me.bContainer.scrollTop();
            t_body = this.t_body;
            h_body = this.h_body;
            b_body = this.b_body;
            f_body = this.f_body;
            grip = this._grip;
            thW = this._thW;

            if (grip) {
                for (var j = 0; j < grip.length; j++) {
                    grip[j].remove();
                }
            }
            t_body.text("");
            h_body.text("");
            b_body.text("");
            f_body.text("");
            if (this.buttons) {
                for (var j = 0; j < this.buttons.length; j++) {
                    this.buttons[j].dispose();
                }
            }
            //title
            var tr = $('<tr>').appendTo(t_body), tw = -3, idx = 0, colspan = 0, title = null;
            for (var nm in this.columns) {
                if (this.columns[nm]) {
                    colspan++;
                }
            }
            //toolbar
            if (this.command) {
                this.buttons = [];
                var toolvar = $('<tr>').addClass("toolbar").appendTo(t_body);
                var th = $('<th>').attr('align', "left").appendTo(toolvar).attr('colSpan', colspan + 1);
                function _click(sender) {
                    me.onCommand &&
                me.onCommand(sender, sender.name);
                }
                for (var nm in me.command) {
                    if (me.command.hasOwnProperty(nm)) {
                        switch (nm) {
                            case 'add':
                                this.buttons.push(new DQ.UI.Button(this, {
                                    layout: DQ.UI.LayoutStyle.Inline,
                                    name: nm, custom: true, className: 'add', text: _("New"), width: '5em', click: _click
                                }));
                                break;
                            case 'delete':
                                this.buttons.push(new DQ.UI.Button(this, {
                                    layout: DQ.UI.LayoutStyle.Inline,
                                    name: nm, custom: true, className: 'delete', text: _("Delete"), width: '5em', click: _click
                                }));
                                break;
                            case 'edit':
                                this.buttons.push(new DQ.UI.Button(this, {
                                    layout: DQ.UI.LayoutStyle.Inline,
                                    name: nm, custom: true, className: 'edit', text: _("Edit"), width: '5em', click: _click
                                }));
                                break;
                            default:
                                this.buttons.push(new DQ.UI.Button(this, {
                                    layout: DQ.UI.LayoutStyle.Inline,
                                    name: nm, custom: true,
                                    className: me.command[nm].className ? me.command[nm].className : "image",
                                    text: _(me.command[nm].name ? me.command[nm].name : nm), width: '5em', click: _click
                                }));
                                break;
                        }
                    }
                }
                for (var j = 0; j < this.buttons.length; j++) {
                    th.append(this.buttons[j].obj);
                }
            }

            if (this._text != "") {
                title = $('<th>').addClass("title").attr('colSpan', colspan + 1).text(this._text).appendTo(tr);
            }
            tr = $('<tr>').appendTo(h_body);
            if (!this._dataSource) {
                return;
            }

            //header
            var thWidth = 0,
            cal = null,
            columns = this.columns;
            idx = 0;
            for (var tn in this._dataSource) {
                if (tn.charAt(0) == '_' && tn.charAt(1) == '_' || typeof this._dataSource[tn] == "function") {
                    continue;
                }
                //見つかった一件からヘッダーを作成
                _grid$createHeader(this._dataSource[tn]);

                if (this.columns && this.columns['del']) {
                    var th = $('<th>').width('22px').appendTo(tr);
                    thWidth += th.outerWidth();
                }
                $('<th>').width('auto').text(' ').appendTo(tr);
                break;
            }

            function _grid$createHeader(dataSource) {
                if (columns) {
                    for (var nm in columns) {
                        var column = columns[nm];
                        if (typeof column == "function") {
                            continue;
                        }
                        if (dataSource[nm]) {
                        }
                        thW.length <= idx && (thW[idx] = column.width);
                        var th = $('<th>').width(thW[idx]).appendTo(tr).attr({ name: nm, idx: idx });
                        if (idx == me._sortPosition) {
                            if (me.sortOrder == DQ.UI.SortOrder.Ascending) {
                                var cal = $('<div>').addClass("dq-sort-asc").appendTo(th).text("▲");
                            } else if (me.sortOrder == DQ.UI.SortOrder.Descending) {
                                var cal = $('<div>').addClass("dq-sort-desc").appendTo(th).text("▼");
                            }
                        }
                        $('<div>').width(thW[idx]).css('overflow', "hidden").text(column.caption || "").appendTo(th);
                        thWidth += th.outerWidth();
                        idx++;
                    }
                } else {
                    for (var nm in dataSource) {
                        if (typeof dataSource[nm] == "function") {
                            continue;
                        }
                        var th = $('<th>').appendTo(tr).attr({ name: nm, idx: idx });
                        $('<div>').width('3em').css('overflow', "hidden").text(nm).appendTo(th);
                        th.width('3em');
                        //thW.length > idx && th.width(thW[idx]);
                        thWidth += th.outerWidth();
                        idx++;
                    }
                }
            }
            function _grid$addRow(row) {
                if (columns) {
                    for (var nm in columns) {
                        if (typeof columns[nm] == "function") {
                            continue;
                        }
                        if (row[nm] == undefined) {
                            //continue;
                        }
                        var column = columns[nm],
                            td = $('<td>').attr('overflow', "hidden").width(thW[c_count]).appendTo(tr),
                            txt = row[nm] == undefined ? (column.type == "number" ? 0 : "") : row[nm];
                        column.align && td.css('text-align', column.align);
                        txt = txt.join ? txt.join(',') : txt;
                        $('<div>').attr('overflow', "hidden").text(txt).width(thW[c_count]).appendTo(td);
                        c_count++;
                    }
                } else {
                    for (var nm in row) {
                        if (typeof row[nm] == "function") {
                            continue;
                        }
                        var td = $('<td>').attr('overflow', "hidden").width('3em').appendTo(tr),
                            txt = row[nm] == undefined ? 'null' : row[nm];
                        txt = txt.join ? txt.join(',') : txt;
                        txt = typeof txt == "object" ? txt.toString() : txt;
                        $('<div>').attr('overflow', "hidden").text(txt).width('3em').appendTo(td);
                        c_count++;
                    }
                }
            }

            if (thWidth > me.width() - 16) {
                thWidth += 16;
                $('>table', me.hContainer).width(thWidth);
            }

            function _grid$dragEnd(e) {
                tw = -3;
                idx = 0;
                var cth = $(th[me.drag.id]),
                w = cth.width() + e.pageX - me.drag.start;
                cth.width(w);
                thW[me.drag.id] = w;
                $(cth.children()[0]).width(w);
                $('tr', me.obj).each(function () {
                    $('td:visible div:eq(' + me.drag.id + ')', this).width(w).parent().width(w);
                });
                th.each(function () {
                    tw += $(this).outerWidth();
                    var cg = $('div[idx="' + idx + '"]', me.obj).css('left', tw).show();
                    tw >= me.width() && cg.hide();
                    idx++;
                });
                $(e.data).removeClass('dq-datagrid-drag').height(me.drag.height);
                DQ.document.unbind("mousemove", _grid$move).unbind("mouseup", _grid$dragEnd);

                delete me.drag;
                return false;
            }
            function _grid$move(e) {
                $(e.data).css('left', me.drag.left + (e.pageX - me.drag.start));
                return false;
            }

            //grip
            idx = 0;
            me._grip = [];
            var top = t_body.height(),
            th = $('>th', tr).hover(
                function () {
                    $(this).addClass('dq-grid-hover');
                },
                function () {
                    $(this).removeClass('dq-grid-hover');
                }
            )
            .each(function () {
                var header = $(this);
                if (idx == me._sortPosition) {
                    cal && cal.css({ top: t_body.height() + "px", left: (tw + header.outerWidth() / 2 - 4) + "px" });
                }
                tw += header.outerWidth();
                thW.length <= idx && (thW[idx] = header.width());
                var cg = $('<div>').addClass("dq-datagrid-grip").attr({ 'idx': idx, 'z-index': 100 })
                .appendTo(me.client)
                .css({ 'left': tw - 2, 'top': top })
                .height(header.outerHeight() + 2)
                .mousedown(function _grid$dragStart(e) {
                    me.drag = { start: e.pageX, id: parseInt($(this).attr('idx')), left: parseInt($(this).css('left')), height: $(this).height() };
                    $(this).addClass('dq-datagrid-drag').height(header.outerHeight() * 2);
                    $(document).bind("mousemove", this, _grid$move);
                    $(document).bind("mouseup", this, _grid$dragEnd);
                    return false;
                });
                tw >= me.width() && cg.hide();
                idx++;
                me._grip.push(cg);
            }).click(function () {
                var x = $(this).attr('name');
                me.sortOrder = me.sortOrder == DQ.UI.SortOrder.Ascending ?
                    DQ.UI.SortOrder.Descending : DQ.UI.SortOrder.Ascending;
                me._dataSource.sort(x, me.sortOrder);
                me._sortPosition = $(this).attr('idx');
                setTimeout(function () {
                    me.bind();
                }, 0);
            });

            this.rows = [];
            for (var tn in this._dataSource) {
                if (tn.charAt(0) == '_' && tn.charAt(1) == '_' || typeof this._dataSource[tn] == "function") {
                    continue;
                }
                var tr = $('<tr>').attr({ key: tn, idx: this.rows.length }).appendTo(b_body)
                    .click(
                        function (e) {
                            e.data = this;
                            me.select(parseInt($(this).attr('idx')));
                            me.onClick && me.onClick(me, e);
                        }
                    )
                    .hover(
                        function () {
                            $(this).addClass('dq-grid-hover');
                        },
                        function () {
                            $(this).removeClass('dq-grid-hover');
                        }
                    );

                this.rows.push(tr);

                var c_count = 0,
                row = this._dataSource[tn];

                _grid$addRow(row);
                if (c_count && this.columns && this.columns['del']) {
                    $('<td>').width(22).appendTo(tr).append($('<div>').addClass('delete').html("&nbsp;"));
                }
            }

            $('tr:odd', b_body).addClass('odd');
            b_body.parent().parent().height(this.obj.height() - h_body.height() - t_body.height() - 1);

            me.bContainer.bind("scroll", function () {
                me.hContainer[0].scrollLeft = me.bContainer[0].scrollLeft
            });
            me.bContainer[0].scrollTop = scrollTop;
        },
        dqid: "DQ.UI.DataGrid",
        _selectedIndex: -1,
        selectedIndex: function (value) {
            if (!arguments.length) {
                return this._selectedIndex;
            } else {
                select(value);
            }
        },
        select: function (index) {
            if (!arguments.length) {
                __dqsuper__(this, "select", arguments);
                return;
            }

            if (index < 0 || this.rows.length <= index) {
                throw new DQ.InvalidArguments("indexの値が不正です。");
            }

            this._selectedIndex = index;
            $('tr', this.b_body).removeClass('select');
            this.rows[index].addClass('select');
            this.onSelectedIndexChanged && this.onSelectedIndexChanged(this, index);
        },
        unselect: function (index) {
            if (index < 0 || this.rows.length < index) {
                throw new DQ.InvalidArguments("indexの値が不正です。");
            }

            this._selectedIndex = -1;
            this.rows[index].removeClass('select');
        },
        resize: function () {
            this.dock(this._dock);
            this.bind();
        },
        update: function () {
            this.dock(this._dock);
            this.bind();
        },
        text: function (value) {
            if (arguments.length == 0) {
                return this._text;
            }

            this._text = value;
            $('.title', this.client).text(this._text);
        }
    }, {
        dataSource: {
            get: function () {
                return this._dataSource;
            },
            set: function (value) {
                this._dataSource = value;
                this.sortOrder = DQ.UI.SortOrder.None;
                this._thW = [];
                this.bind();
            }
        }
    });

    DQ._ctrl_['dq-datagrid'] = DQ.UI.DataGrid;
});
