﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="../dq-core.js" />
/// <reference path="dq-ui.js" />
/*
* DQ Retro game UI framework JavaScript library version v0.6.0
*
* Copyright (c) 2009-2010 M., Koji
* Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
*
* Date: 2009-11-01 17:34:21 -0900
* Revision: 0004
*/

DQ.lazyLoad(DQ.subdir + "ui/dq-ui.js", "DQ.UI", function () {

    DQ.UI.TreeNodeCollection = dqextend(Array, function (parent, options) {
        this.base(options);
        this.parent = parent;
        this.obj = $('<div>');
        this.parent.append(this.obj, true);
        if (parent.dqid == "DQ.UI.TreeView") {
            this.treeView = parent;
        }
        return this;
    }, {
        obj: null,
        add: function (treeNode) {
            return this.push(treeNode);
        },
        push: function (treeNode) {
            this.__super.push.apply(this, arguments);
            this.parent.add(treeNode);
            treeNode._treeView = this.treeView;
        },
        bind: function (url, cache) {
            cache = cache == undefined ? false : cache;

            this._clear();
            var b = this.parent._text;
            this.parent.text("データを読み込みます");
            this._clear();
            var me = this;
            setTimeout(function () {
                $.ajax(
                    {
                        cache: cache,
                        type: "GET",
                        url: url,
                        success: function (data) {
                            me.parent.text(b);
                            eval("var s = " + data);
                            me.json(s);
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            alert(DQ.format("{0}: {1} {2}", XMLHttpRequest.status, XMLHttpRequest.statusText, textStatus));
                        }
                    });
            }, 15.625);
        },
        json: function (data) {
            for (var nm in data) {
                var node = new DQ.UI.TreeNode(this.treeView, nm);
                this.push(node);
                node.tag = typeof data[nm] == "object" ? null : data[nm];
                typeof data[nm] == "string" && node.toolTipText(data[nm]);
                node.json(data[nm]);
            }
        },
        _clear: function () {
            for (var i = 0; i < this.length; i++) {
                this[i].dispose();
            }
            this.length = 0;
        },
        dispose: function () {
            this._clear();
            this.obj.remove();
        }
    });

    DQ.UI.TreeView = dqextend(DQ.Control, function (parent, options, object) {
        /// <summary>
        /// TreeViewコントロールを作成します。
        /// </summary>
        ///<param name="options" type="object">
        /// オプションを指定
        ///</param>
        /// <param name="object" type="jQuery">
        /// TreeViewコントロールの外殻を指すオブジェクトを指定
        /// </param>

        //options 省略判定
        object = !object && options && (typeof options == "string" || options.jquery) && options || object;
        object = object || $('<div>').addClass('dq-treeview');
        options = options || {};

        this.base(parent, object);
        this.name = options.name || (typeof object == "string") ? object : object.attr('id');
        this.obj.addClass('dq-treeview');

        var o = this._outer = $('<div>').addClass("outer").appendTo(this.obj);
        this.client = $('<div>').addClass("inner").appendTo(o);
        this.Nodes = new DQ.UI.TreeNodeCollection(this);
        this.show();
        var url = options.imageURL || "";
        this.imageList(url);
        o.height(parseInt(this.obj.css('height')) - 4);
        return this;
    }, {
        onAfterSelect: null,
        append: function (element) {
            if (element.dqid) {
                this.client.append(element.obj);
                this.controls.push(element);
            } else {
                this.client.append(element);
            }
            this._addControls(this, this.controls.length - 1);
        },
        add: function (treeNode) {
            this.Nodes.obj.append(treeNode.obj);
        },
        collapseAll: function () {

        },
        dqid: "DQ.UI.TreeView",
        labelClick: function (node) {
            this.onClick && this.onClick(node);
        },
        expandAll: function () {
        },
        imageURL: "",
        _imageIndex: 0,
        imageIndex: function (value) {
            ///<summary>
            /// ImageListのimageの位置を指定します。
            ///</summary>
            if (!arguments.length) {
                return this._imageIndex;
            }
            this._imageIndex = value;
            for (var i = 0; i < this.Nodes.length; i++) {
                this.Nodes[i]._setupPosition();
            }
        },
        imageList: function (value) {
            if (!arguments.length) {
                return this._imageList;
            }
            if (typeof value == "string") {
                this._imageList = new DQ.UI.ImageList(value);
            } else {
                this._imageList = value;
            }
            $('.img', this.client).css('background-image', 'url(' + this._imageList.sprite + ')');
        },
        Nodes: null,
        _selectedNode: null,
        selectedNode: function (node) {
            if (!arguments.length) {
                return this._selectedNode;
            }
            if (this._selectedNode) {
                this._selectedNode._selected(false);
            }
            this._selectedNode = node;
            this._selectedNode._selected(true);
            this.onAfterSelect && this.onAfterSelect(node);
        },
        resize: function() {
            this.dock(this._dock);
            this._outer.height(parseInt(this.obj.css('height')) - 6);
        },
        update: function () {
            this.dock(this._dock);
            this._outer.height(parseInt(this.obj.css('height')) - 6);
        }
    });

    DQ.UI.TreeNode = dqextend(DQ.Control, function (treeView, label, options) {
        options = options || {};
        var node = $('<div>').addClass("dq-treenode");
        this.base(null, node);
        this._text = label;
        return this._create(treeView, options);
    }, {
        onAfterClick: null,
        _afterClick: function (node, e) {

        },
        add: function (treeNode) {
            var lv = treeNode._level = this._level + 1;
            if (lv) {
                var rb = treeNode._expObj.before($('<span class="rb">&nbsp;</span>'));
                for (var i = 1; i < lv; i++) {
                    var lb = rb.before($('<span class="bar">&nbsp;</span>'));
                }
            }
            this.Nodes.obj.append(treeNode.obj);
            this._expObj.removeClass('none');
            this._expObj.addClass('expand');
        },
        collapse: function () {
            if (!this.Nodes.length) {
                return;
            }
            if (this.expanded) {
                this._expObj.removeClass('none');
                this._expObj.removeClass('expand');
                this._expObj.addClass('collapse');
                this.expanded = false;
                this.Nodes.obj.hide();
            }
        },
        _create: function (treeView, options) {
            this._treeView = treeView;
            this._expObj = $('<span class="exp dq-treeimage none">&nbsp;</span>').appendTo(this.obj);
            this._boxObj = $('<span class="box"></span>').appendTo(this.obj);
            this._imgObj = $('<span class="img" style="background-image: url(' + treeView.imageList().sprite + ')">&nbsp;</span>').appendTo(this.obj);
            this._txtObj = $('<span class="txt">' + this._text + '</span>').appendTo(this.obj);

            this.Nodes = new DQ.UI.TreeNodeCollection(this);
            this.Nodes.treeView = treeView;

            this._expObj.bind("click", this, function (e) { var me = e.data; me.toggle.apply(me); });
            this._boxObj.bind("click", this, function (e) { var me = e.data; var t = me.treeView(); t && t.labelClick(me); });
            this.imageIndex(treeView.imageIndex());
            this._txtObj.bind("click", this, function (e) { var me = e.data; me.treeView().selectedNode(me); });

            options.toolTip && this.toolTipText(options.toolTip);
            return this;
        },
        dispose: function () {
            this._expObj.unbind("click");
            this._txtObj.unbind("click");
            this.Nodes.dispose();
            __dqsuper__(this, "dispose");
        },
        dqid: "DQ.UI.TreeNode",
        expanded: true,
        expand: function () {
            if (!this.Nodes.length) {
                return;
            }
            if (!this.expanded) {
                this._expObj.removeClass('none');
                this._expObj.removeClass('collapse');
                this._expObj.addClass('expand');
                this.expanded = true;
                this.Nodes.obj.show();
            }
        },
        _setupPosition: function (disable) {
            var index = this._imageIndex ? this._imageIndex : this._treeView.imageIndex();
            if (index == -1) {
                this._imgObj.hide();
            } else {
                this._imgObj.css('background-position', (index * -18) + "px 0px");
                this._imgObj.show();
            }
            if (!disable && this.Nodes) {
                for (var i = 0; i < this.Nodes.length; i++) {
                    this.Nodes[i]._setupPosition();
                }
            }
        },
        _imageIndex: -1,
        imageIndex: function (pos) {
            if (!arguments.length) {
                return this._imageIndex;
            }
            this._imageIndex = pos;
            this._setupPosition(true);
        },
        json: function (data) {
            if (typeof data == "string") {
                this.url = data;
            } else {
                this.Nodes.json(data);
            }
        },
        toggle: function () {
            this.expanded ? this.collapse() : this.expand();
        },
        _isSelected: false,
        isSelected: function () {
            return this._isSelected;
        },
        Nodes: null,
        _level: 0,
        level: function () { return this._level; },
        _selected: function (value) {
            if (!value) {
                this._txtObj.removeClass('dq-treenode-selected');
            } else {
                this._txtObj.addClass('dq-treenode-selected');
            }
            this._isSelected = value;
        },
        text: function (data) {
            if (!data) {
                return this._text;
            }
            this._text = data;
            this._txtObj.text(data);
        },
        toolTipText: function (data) {
            if (!data) {
                return this.client.attr('title');
            }
            this.client.attr('title', data)
        },
        _treeView: null,
        treeView: function () {
            if (this._treeView != null) {
                return this._treeView;
            }
            var p = this.parent;
            while (p != null) {
                if (p._treeView != null) {
                    this._treeView = p._treeView;
                    break;
                }
                p = p.parent;
            }
            return this._treeView;
        }
    });

    DQ._ctrl_['dq-treeview'] = DQ.UI.TreeView;
});