﻿/// <reference path="../jquery.js" />
/// <reference path="../dq.js" />
/// <reference path="../dq-core.js" />
/// <reference path="dq-ui.js" />

/*
** DQ Retro game UI framework JavaScript library version v0.6.0
**
** Copyright (c) 2011 M., Koji
** Licensed under the MIT License: http://www.opensource.org/licenses/mit-license.php
**
** Date: 2011-08-01 17:34:21 -0900
** Revision: 0001
**
**/

DQ.lazyLoad(DQ.subdir + "dq-core.js", "DQ.UpDownBase", function () {
    DQ.lazyLoad(DQ.subdir + "ui/dq-ui.js", "DQ.UI", function () {
        DQ.UI.NumericUpDown = dqextend(DQ.UpDownBase, function (parent, options, object) {
            this.base(parent, options, object);
            this._textBox.focusout(this, function (e) {
                var me = e.data;
                var num = parseFloat(me.text());
                if (isNaN(num)) {
                    me.text(options.value);
                } else if (num > me.maximum) {
                    num = me.maximum;
                    me.text(num);
                } else if (num < me.minimum) {
                    num = me.minimum;
                    me.text(num);
                }
            });
            options = DQ.options(options, {
                minimum: 0,
                maximum: 9999,
                value: 0
            });
            this.minimum = options.minimum;
            this.maximum = options.maximum;
            if (isNaN(parseFloat(options.value))) {
                throw new Error("DQ.UI.NumericUpDown:: invalue value");
            }
            this.text(options.value);

        },
    {
        downButton: function (e) {
            var me = e.data;
            var num = parseFloat(me.text());
            num > me.minimum && (num--);
            me.text(num);
        },
        upButton: function (e) {
            var me = e.data;
            var num = parseFloat(me.text());
            num < me.maximum && (num++);
            me.text(num);
        },
        minimum: 0,
        maximum: 9999
    });

        DQ._ctrl_['dq-nm-updown'] = DQ.UI.NumericUpDown;
    });
});